QCPSelectionDecorator Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Functions | Protected Functions
QCPSelectionDecorator Class Reference

Controls how a plottable's data selection is drawn. More...

Inheritance diagram for QCPSelectionDecorator:

## Public Functions
| QCPSelectionDecorator ()
QPen | pen () const
QBrush | brush () const
QCPScatterStyle | scatterStyle () const
QCPScatterStyle::ScatterProperties | usedScatterProperties () const
void | setPen (const QPen &pen)
void | setBrush (const QBrush &brush)
void | setScatterStyle (const QCPScatterStyle &scatterStyle, QCPScatterStyle::ScatterProperties usedProperties=QCPScatterStyle::spPen)
void | setUsedScatterProperties (const QCPScatterStyle::ScatterProperties &properties)
void | applyPen (QCPPainter *painter) const
void | applyBrush (QCPPainter *painter) const
QCPScatterStyle | getFinalScatterStyle (const QCPScatterStyle &unselectedStyle) const
virtual void | copyFrom (const QCPSelectionDecorator *other)
virtual void | drawDecoration (QCPPainter *painter, QCPDataSelection selection)

## Protected Functions
virtual bool | registerWithPlottable (QCPAbstractPlottable *plottable)

## Detailed Description

Controls how a plottable's data selection is drawn.

Each QCPAbstractPlottable instance has one QCPSelectionDecorator (accessible via QCPAbstractPlottable::selectionDecorator) and uses it when drawing selected segments of its data.

The selection decorator controls both pen (setPen) and brush (setBrush), as well as the scatter style (setScatterStyle) if the plottable draws scatters. Since a QCPScatterStyle is itself composed of different properties such as color shape and size, the decorator allows specifying exactly which of those properties shall be used for the selected data point, via setUsedScatterProperties.

A QCPSelectionDecorator subclass instance can be passed to a plottable via QCPAbstractPlottable::setSelectionDecorator, allowing greater customizability of the appearance of selected segments.

Use copyFrom to easily transfer the settings of one decorator to another one. This is especially useful since plottables take ownership of the passed selection decorator, and thus the same decorator instance can not be passed to multiple plottables.

Selection decorators can also themselves perform drawing operations by reimplementing drawDecoration, which is called by the plottable's draw method. The base class QCPSelectionDecorator does not make use of this however. For example, QCPSelectionDecoratorBracket draws brackets around selected data segments.

## Constructor & Destructor Documentation

## § QCPSelectionDecorator()

QCPSelectionDecorator::QCPSelectionDecorator | ( |  | ) |

Creates a new QCPSelectionDecorator instance with default values

## Member Function Documentation

## § setPen()

void QCPSelectionDecorator::setPen | ( | const QPen & | pen | ) |

Sets the pen that will be used by the parent plottable to draw selected data segments.

## § setBrush()

void QCPSelectionDecorator::setBrush | ( | const QBrush & | brush | ) |

Sets the brush that will be used by the parent plottable to draw selected data segments.

## § setScatterStyle()

void QCPSelectionDecorator::setScatterStyle | ( | const QCPScatterStyle & | scatterStyle,
|  | QCPScatterStyle::ScatterProperties | usedProperties = `QCPScatterStyle::spPen`
| ) |  |

Sets the scatter style that will be used by the parent plottable to draw scatters in selected data segments.

usedProperties specifies which parts of the passed scatterStyle will be used by the plottable. The used properties can also be changed via setUsedScatterProperties.

## § setUsedScatterProperties()

void QCPSelectionDecorator::setUsedScatterProperties | ( | const QCPScatterStyle::ScatterProperties & | properties | ) |

Use this method to define which properties of the scatter style (set via setScatterStyle) will be used for selected data segments. All properties of the scatter style that are not specified in properties will remain as specified in the plottable's original scatter style.

See also
  QCPScatterStyle::ScatterProperty

## § applyPen()

void QCPSelectionDecorator::applyPen | ( | QCPPainter * | painter | ) | const

Sets the pen of painter to the pen of this selection decorator.

See also
  applyBrush, getFinalScatterStyle

## § applyBrush()

void QCPSelectionDecorator::applyBrush | ( | QCPPainter * | painter | ) | const

Sets the brush of painter to the brush of this selection decorator.

See also
  applyPen, getFinalScatterStyle

## § getFinalScatterStyle()

QCPScatterStyle QCPSelectionDecorator::getFinalScatterStyle | ( | const QCPScatterStyle & | unselectedStyle | ) | const

Returns the scatter style that the parent plottable shall use for selected scatter points. The plottable's original (unselected) scatter style must be passed as unselectedStyle. Depending on the setting of setUsedScatterProperties, the returned scatter style is a mixture of this selecion decorator's scatter style (setScatterStyle), and unselectedStyle.

See also
  applyPen, applyBrush, setScatterStyle

## § copyFrom()

void QCPSelectionDecorator::copyFrom | ( | const QCPSelectionDecorator * | other | ) |
| virtual

Copies all properties (e.g. color, fill, scatter style) of the other selection decorator to this selection decorator.

## § drawDecoration()

void QCPSelectionDecorator::drawDecoration | ( | QCPPainter * | painter,
|  | QCPDataSelection | selection
| ) |  |
| virtual

This method is called by all plottables' draw methods to allow custom selection decorations to be drawn. Use the passed painter to perform the drawing operations. selection carries the data selection for which the decoration shall be drawn.

The default base class implementation of QCPSelectionDecorator has no special decoration, so this method does nothing.

Reimplemented in QCPSelectionDecoratorBracket.

## § registerWithPlottable()

bool QCPSelectionDecorator::registerWithPlottable | ( | QCPAbstractPlottable * | plottable | ) |
| protectedvirtual

This method is called as soon as a selection decorator is associated with a plottable, by a call to QCPAbstractPlottable::setSelectionDecorator. This way the selection decorator can obtain a pointer to the plottable that uses it (e.g. to access data points via the QCPAbstractPlottable::interface1D interface).

If the selection decorator was already added to a different plottable before, this method aborts the registration and returns false.

The documentation for this class was generated from the following files:

- src/plottable.h
- src/plottable.cpp